"use strict";
const {classes: Cc, interfaces: Ci, results: Cr, utils: Cu} = Components;
var appCore;
switch (APP_NAME) {
case "yasearch":
appCore = Cc["@yandex.ru/custombarcore;yasearch"].getService().wrappedJSObject;
break;
case "yandex-vb":
appCore = Cc["@yandex.ru/vb-core;1"].getService().wrappedJSObject;
break;
default:
throw new Error("Unknown application type '" + APP_NAME + "'");
}

(function (global) {
window.addEventListener("load",function onload(event) {
window.removeEventListener("load",onload,false);
collectInfo();
}
,false);
global.collectInfo = function collectInfo() {
var setCollectingState = (function setCollectingState(aDisabled) {
this.classList[aDisabled ? "add" : "remove"]("wait");
}
).bind($("collect-info"));
setCollectingState(true);
hide($("send-info"));
Snapshoter.capture(function formatSnapshot(snapshot) {
for(let prop in formatters) formatters[prop](snapshot[prop]);
packManager.prepeare(snapshot);
setCollectingState(false);
}
);
}
;
global.savePack = function savePack() {
packManager.savePack();
}
;
const IOService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
const fileutils = appCore.Lib.fileutils;
const DataURI = Cu.import("resource://" + APP_NAME + "-mod/DataURI.jsm",{
}).DataURI;
var browserWindow = window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShellTreeItem).rootTreeItem.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindow);
var packManager = {
_pack: null,
savePack: function packManager_savePack() {
var excludeFileNames = [];
var packFiles = this._pack.files;
for(let fileType in packFiles) {
if ($(fileType + "-to-send").querySelector("input[type='checkbox']").checked)
continue;
if (isHidden($(fileType + "-to-send")))
continue;
excludeFileNames.push(packFiles[fileType]);
}

if (excludeFileNames.length === Object.keys(packFiles).length)
return;
hide($("send-info"));
show($("rebuild-pack"));
if (excludeFileNames.length)
{
let zipWriter = Cc["@mozilla.org/zipwriter;1"].createInstance(Ci.nsIZipWriter);
zipWriter.open(this._pack.zipFile,fileutils.MODE_RDWR);
excludeFileNames.forEach(function (fileName) zipWriter.removeEntry(fileName,false));
zipWriter.close();
}

var displayDirectory;
var dirService = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
["DfltDwnld", "Desk", "Home"].forEach(function (dirType) {
if (displayDirectory)
return;
try {
displayDirectory = dirService.get(dirType,Ci.nsIFile);
}
catch (e) {

}

}
);
var filePicker = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);
if (displayDirectory)
filePicker.displayDirectory = displayDirectory;
filePicker.defaultString = this._pack.zipFile.leafName;
filePicker.init(window,null,filePicker.modeSave);
var rv = filePicker.show();
if (rv == Ci.nsIFilePicker.returnOK || rv == Ci.nsIFilePicker.returnReplace)
{
let fileName = filePicker.file.leafName.replace(/(\.zip)?$/i,".zip");
this._pack.zipFile.moveTo(filePicker.file.parent,fileName);
}

}
,
prepeare: function packManager_prepeare(aSnapshot) {
this._pack = null;
var supportDir = appCore.rootDir;
supportDir.append("support");
fileutils.forceDirectories(supportDir);
var debugLogFile = appCore.rootDir;
debugLogFile.append("debug.log");
var supportInfoFile = supportDir.clone();
supportInfoFile.append("info.json");
fileutils.writeTextFile(supportInfoFile,JSON.stringify(aSnapshot,null,"\t"));
var fastdialInfoFile = supportDir.clone();
fastdialInfoFile.append("fastdial.json");
var fastdialJSON = Snapshoter.getFastdialInfo();
if (fastdialJSON)
fileutils.writeTextFile(fastdialInfoFile,JSON.stringify(fastdialJSON,null,"\t"));
var browser = browserWindow.gBrowser;
var selectedTab = browser.selectedTab;
browserWindow.BrowserOpenTab();
var newTab = browser.selectedTab;
browser.selectedTab = selectedTab;
appCore.Lib.sysutils.sleep(50);
browser.hideTab(newTab);
appCore.Lib.sysutils.sleep(2000);
browser.selectedTab = newTab;
appCore.Lib.sysutils.sleep(100);
var canvas = document.getElementById("screenshot-canvas");
var context = canvas.getContext("2d");
canvas.height = browserWindow.innerHeight;
canvas.width = browserWindow.innerWidth;
context.drawWindow(browserWindow,0,0,canvas.width,canvas.height,"rgba(0,0,0,0)");
browser.removeCurrentTab({
animate: false});
browser.selectedTab = selectedTab;
var screenFile = supportDir.clone();
screenFile.append("screenshot.png");
var screenDataURL = canvas.toDataURL("image/png","");
var screenURI = IOService.newURI(screenDataURL,null,null);
var stream = IOService.newChannelFromURI(screenURI).open();
fileutils.writeStreamToFile(stream,screenFile);
var supportZipFile = appCore.rootDir;
supportZipFile.append(APP_NAME + ".support.zip");
fileutils.removeFileSafe(supportZipFile);
var jarSpec = "jar:" + IOService.newFileURI(supportZipFile).spec + "!/";
this._pack = {
zipFile: supportZipFile,
files: {
log: "debug.log",
info: "info.json",
screenshot: "screenshot.png",
fastdial: "fastdial.json"},
getURL: function packInfo_getURL(aType) {
return jarSpec + this.files[aType];
}
,
getDataURL: function packInfo_getDataURL(aType) {
if (aType == "screenshot")
return screenDataURL;
var uri = IOService.newURI(this.getURL(aType),null,null);
var channel = IOService.newChannelFromURI(uri);
return "data:text/plain;charset=utf-8;base64," + DataURI.encodeFileStream(channel.open());
}
};
var zipWriter = Cc["@mozilla.org/zipwriter;1"].createInstance(Ci.nsIZipWriter);
var compressionLevel = zipWriter.COMPRESSION_BEST;
zipWriter.open(supportZipFile,fileutils.MODE_WRONLY | fileutils.MODE_CREATE | fileutils.MODE_TRUNCATE);
if (debugLogFile.exists())
zipWriter.addEntryFile(debugLogFile.leafName,compressionLevel,debugLogFile,false); else
delete this._pack.files.log;
if (fastdialInfoFile.exists())
zipWriter.addEntryFile(fastdialInfoFile.leafName,compressionLevel,fastdialInfoFile,false); else
delete this._pack.files.fastdial;
zipWriter.addEntryFile(supportInfoFile.leafName,compressionLevel,supportInfoFile,false);
zipWriter.addEntryFile(screenFile.leafName,compressionLevel,screenFile,false);
zipWriter.close();
fileutils.removeFileSafe(supportDir);
this._showForm();
}
,
_showForm: function packManager__showForm() {
show($("send-info"));
for(let fileType in this._pack.files) {
let elem = $(fileType + "-to-send");
show(elem);
elem.querySelector("input[type='checkbox']").checked = true;
elem.querySelector("a").href = this._pack.getURL(fileType);
elem.querySelector("a").onclick = (function _showFileInTab(type) {
this._showFileInTab(type);
return false;
}
).bind(this,fileType);
}

}
,
_showFileInTab: function packManager__showFileInTab(aFileType) {
var url = this._pack.getDataURL(aFileType);
browserWindow.gBrowser.selectedTab = browserWindow.gBrowser.addTab(url);
}
};
var formatters = {
extension: function formatters_extension(data) {
$("version-box").textContent = data.version;
$("date-box").textContent = data.date;
}
,
application: function formatters_application(data) {
$("useragent-box").textContent = data.userAgent;
$("os-box").textContent = data.os;
var version = data.version;
if (data.vendor)
version += " (" + data.vendor + ")";
$("browser-box").textContent = data.name + "; " + version;
if (data.theme)
{
show($("theme-box").parentNode);
$("theme-box").textContent = data.theme;
}

if (data.lightweightTheme)
{
show($("lightweightTheme-box").parentNode);
$("lightweightTheme-box").textContent = data.lightweightTheme;
}

}
,
extensions: function formatters_extensions(data) {
append($("extensions-tbody"),data.map(function (extension) {
return create("tr",[create("td",extension.name), create("td",extension.version), create("td",extension.isActive,"center"), create("td",extension.id), create("td",extension.homepageURL)]);
}
));
}
,
components: function formatters_components(data) {
if (! Array.isArray(data) || ! data.length)
return;
show($("components"));
data.forEach(function (package_) {
append($("components-tbody"),[create("tr",[create("td",package_.id + " (" + package_.version + ")","packageName"), create("td","")])]);
append($("components-tbody"),package_.components.map(function (component) {
return create("tr",[create("td",component.name,"componentName"), create("td",typeof component.enabled == "boolean" ? component.enabled : "","center")]);
}
));
}
);
}
,
modifiedBrowserPreferences: function formatters_modifiedBrowserPreferences(data) {
appendModifiedPreferences($("browser-preferences-tbody"),data);
}
,
modifiedExtensionPreferences: function formatters_modifiedExtensionPreferences(data) {
appendModifiedPreferences($("extension-preferences-tbody"),data);
}
};
var $ = document.getElementById.bind(document);
function create(tag, children, classNames) {
var elt = document.createElementNS("http://www.w3.org/1999/xhtml",tag);
if (classNames)
classNames.split(/\s+/).forEach(function (className) elt.classList.add(className));
if (Array.isArray(children))
append(elt,children); else
elt.textContent = String(children);
return elt;
}

function append(parent, children) children.forEach(function (c) parent.appendChild(c))
function show(element) element.classList.remove("hidden")
function hide(element) element.classList.add("hidden")
function isHidden(element) element.classList.contains("hidden")
function appendModifiedPreferences(element, data) {
append(element,sortedArrayFromObject(data).map(function ([name, value]) {
var val = String(value);
if (val.length > 240)
val = val.substr(0,240) + "\u2026";
return create("tr",[create("td",name,"pref-name"), create("td",val,"pref-value")]);
}
));
}

function sortedArrayFromObject(obj) [[name, value] for ([name, value] in Iterator(obj))].sort(function ([name1, value1], [name2, value2]) name1.localeCompare(name2))
}
)(this);
